import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class ReseauFilesAttentes {
    public static final int duree = 10000;
    public static final int nbServeurs = 3;
    public static final double q = 1./3;
    public static final double p = 0.5;
    public static ArrayList<Requete> coordinateur = new ArrayList<>();
    public static ArrayList<Requete> serveur1 = new ArrayList<>();
    public static ArrayList<Requete> serveur2 = new ArrayList<>();
    public static ArrayList<Requete> serveur3 = new ArrayList<>();
    public static ArrayList<Requete> sortie = new ArrayList<>();
    public static ArrayList<Double> traitement = new ArrayList<>();

    public static double equation4(double l) {
        double r = Math.random();
        return -Math.log(1-r)/l;
    }

    public static void enregistrerLesDonnees(String filename, String partieNom, String contenu) {
        try {
            String filepath = System.getProperty("user.dir") + File.separator + "data/" + filename
                    + String.valueOf(partieNom) + ".dat";
            System.out.println("Ecriture du fichier : " + filepath);
            FileWriter fw = new FileWriter(filepath);
            BufferedWriter bw = new BufferedWriter(fw);
            bw.write(contenu);
            bw.close();
        } catch ( IOException e) {
            e.printStackTrace();
        }
    }

    public static int lesDonneesCoordinateur(double lambda,double mu){
        String contenuEntree = "";
        String contenuSortie = "";
        double x=0;//le temps d'entre
        int y=0;
        double leTempsTraitement;
        Requete r = new Requete(0,0,0);
        while (r.getDateEntree() < duree)
        {
            x=x+equation4(lambda);
            if(x>duree) break;
            r.setDateEntree(x);
            r.setId(y);
            contenuEntree += r.getId()+" "+r.getDateEntree()+"\n";
            leTempsTraitement = equation4(mu);
            traitement.add(y,leTempsTraitement);
            if(y==0){
                //le temps sortie égale au temps Entree+le temps Traitement(equation4(mu))
                r.setDateSortie(r.getDateEntree()+leTempsTraitement);
            }else{
                if(r.getDateSortie()<r.getDateEntree())
                    r.setDateSortie(r.getDateEntree()+leTempsTraitement);
                else
                    r.setDateSortie(r.getDateSortie()+leTempsTraitement);
            }
            coordinateur.add(r);
            contenuSortie+=y+" "+r.getDateSortie()+"\n";
            y++;
        }
        enregistrerLesDonnees("entree","" ,contenuEntree);
        enregistrerLesDonnees("sortie", "",contenuSortie);
        return y;
    }

    /*public boolean isConvergence(){
        if(lambda/mu<1) return true;
        else return false;//le systèm n'arrete pas,c'est un systèm infini
    }*/

    public static void main(String[] args) {
        System.out.println("**************************************");
        System.out.println(lesDonneesCoordinateur(0.5,0.5));
    }
}
